

Public Class FirmwareUpdate

    Private Sub Load_FirmwareUpdate(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If (m_nConnectState = 0) Then
            txSeriennummer.Text = ""
            txFirmware.Text = ""
            RichDataBox.Text = ""
        End If
    End Sub

    Private Sub FileDlg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FileDlg.Click

        ' Hier whlen wir eine zu bertragende Firmware aus
        Dim l_csFirmware As String = String.Empty
        m_sFirmware = String.Empty
        With FileDialog
            .FileName = ""
            .CheckFileExists = True : .CheckPathExists = True
            .Filter = "MasterIV Gertedatei (*.hex)|*.hex|" & _
                      "MasterIV Gertedateien (*.dfz)|*.dfz|" & _
                      "MasterIV Gertedateien (*.hex; *.dfz)|*.hex; *.dfz|" & _
                      "All Files (*.*)|*.*"
            .Multiselect = False : .ReadOnlyChecked = False
            .RestoreDirectory = True : .ShowHelp = False
            .Title = "Select File - DFComLL Sample."
            .ShowDialog(Me)
            m_sFirmware = .FileName.ToString().Trim()
        End With

        If m_sFirmware.ToString().Trim().Length = 0 Then
            Exit Sub
        Else
            If (m_sFirmware.ToString().Trim().Length > 85) Then
                Dim xpos As Integer
                '  Dim ypos As Integer
                l_csFirmware = m_sFirmware.ToString().Trim()
                xpos = l_csFirmware.ToString().Trim().Length - 50
                '       ypos = file_name.ToString().Trim().Length
                txFirmwarePath.Text = l_csFirmware.Substring(0, 25) & " ... \" & l_csFirmware.Substring(xpos, 50)
            Else
                txFirmwarePath.Text = m_sFirmware.ToString().Trim()
            End If
        End If

    End Sub

    Private Sub FWUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FWUpdate.Click

        Dim iDFComResult As Integer ' Rckgabewert der DFComDLL Funktionsaufrufe
        Dim DSName As String ' Name eine Datensatzbeschreibung
        Dim DSField As String ' Name eines Feldes
        Dim length(33) As Char
        DSName = New String(length) ' Bereitstellung des Speichers
        DSField = New String(length) ' Bereitstellung des Speichers

        Dim Datensatz As String ' Gelesener Datensatz
        Dim Slength(241) As Char ' max. Lnge eines Datensatzes

        Dim DSFieldTyp As Integer ' Feldtyp eines Datensatzfeldes
        Dim DSFieldLength As Integer ' Lnge eines Feldes laut Datensatzbeschreibung
        Dim DSLength As Integer ' Datensatzlnge
        Dim DSStatus As Integer ' Status eines gelesenen Datensatzes (online, offline, ...)

        ' Vorbereitung fr anzuzeigende Messageboxen
        Dim style As MsgBoxStyle
        Dim style2 As MsgBoxStyle
        Dim response As MsgBoxResult
        style = MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly
        style2 = MsgBoxStyle.Exclamation Or MsgBoxStyle.YesNo

        Dim nComError As Integer = 0
        Dim szComError As String
        Dim cErrorLength(255) As Char
        szComError = New String(cErrorLength)
        Dim szLinkTyp As String
        Dim MsgTitle As String
        Dim MsgStyle As MsgBoxStyle
        MsgStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly
        MsgTitle = ""
        szLinkTyp = ""
        RichDataBox.Text = ""

        RichDataBox.AcceptsTab = True

        '  Dim th As New thr

        ' Hier wird das Firmwareupdate ausgefhrt
        ' Hier wird ausgewhlt, welcher Aufrufvariante der DLL zum Einsatz kommt

        ' Hier CallBack Test
        ''bCallBack = True
        ''CallingVariations.DFCSetCallBack_Declare(1, AddressOf Result_From_CallBack)
        Select Case m_nLinkDLLType
            Case 1 ' Declare
                iDFComResult = CallingVariations.DFCUpload_Declare(1, 254, m_sFirmware.ToString().Trim(), nComError)
            Case 2 ' Import
            Case 3 ' Unicode
            Case 4 ' ANSI 
                iDFComResult = CallingVariations.DFCUpload_ANSI(1, 254, m_sFirmware.ToString().Trim(), nComError)
            Case 5 ' Auto
        End Select
        ''bCallBack = False
        ''DFComDLLSample.MainProgressBar.Value = 0

        If (iDFComResult = 0) Then
            ' Es befinden sich noch Daten im Gert
            If (nComError = 15) Then
                ' Wir geben hier ein Feedback fr den Anwender
                RichDataBox.AppendText("Es sind noch Daten im Gert!")
                RichDataBox.AppendText(vbCrLf)
                response = MsgBox("Es befinden sich noch Daten im Gert," & vbCrLf & _
                        "sollen die Daten jetzt gelesen und gelscht werden?" & vbCrLf _
                        , style2, "Fehler - bei Firmwareupdate")
                ' Die Daten werden gelesen und im Gert gelscht
                If response = MsgBoxResult.Yes Then

                    ' Als erstes mssen wir die Datensatzbeschreibung auslesen
                    Select Case m_nLinkDLLType
                        Case 1 ' declare
                            iDFComResult = CallingVariations.DFCLoadDatensatzbeschreibung_Declare(1, 254, nComError)
                        Case 2 ' import
                        Case 3 ' unicode
                        Case 4 ' ansi 
                            iDFComResult = CallingVariations.DFCLoadDatensatzbeschreibung_ANSI(1, 254, nComError)
                        Case 5 ' auto
                    End Select
                    ' Wir geben hier ein Feedback fr den Anwender
                    RichDataBox.AppendText("Datensatzbeschreibungen aus dem Gert auslesen: <DFCLoadDatensatzbeschreibung()>")
                    RichDataBox.AppendText(vbCrLf)

                    If (iDFComResult = 1) Then

                        ' prfen wie viele Datensatzbeschreibungen definiert sind
                        Select Case m_nLinkDLLType
                            Case 1 ' Declare
                                GlobalDefs.DsbCount = CallingVariations.DFCDatBCnt_Declare(1)
                            Case 2 ' Import
                            Case 3 ' Unicode
                            Case 4 ' ANSI 
                                GlobalDefs.DsbCount = CallingVariations.DFCDatBCnt_ANSI(1)
                            Case 5 ' Auto
                        End Select
                        ' Wir geben hier ein Feedback fr den Anwender
                        RichDataBox.AppendText("Anzahl der Datensatzbeschreibungen ermitteln: <DFCDatBCnt()>")
                        RichDataBox.AppendText(vbCrLf)

                        ' Speicher fr die Datensatzbeschreibungen alokieren
                        ReDim STR(GlobalDefs.DsbCount)

                        ' Das ganze muss fr jede Datensatzbeschreibung abgearbeitet werden
                        For ds As Integer = 0 To GlobalDefs.DsbCount - 1
                            ' Name der Datensatzbeschreibung ermitteln und speichern
                            Select Case m_nLinkDLLType
                                Case 1 ' Declare
                                    CallingVariations.DFCDatBDatensatz_Declare(1, ds, DSName, GlobalDefs.DsbFieldCount)
                                Case 2 ' Import
                                Case 3 ' Unicode
                                Case 4 ' ANSI 
                                    CallingVariations.DFCDatBDatensatz_ANSI(1, ds, DSName, GlobalDefs.DsbFieldCount)
                                Case 5 ' Auto
                            End Select

                            STR(ds).ReID = ds                               ' Nummer der Datensatzbeschreibung
                            STR(ds).ReName = DSName                         ' Name der Datensatzbeschreibung
                            STR(ds).ReFieldCount = GlobalDefs.DsbFieldCount   ' Anzahl Felder 
                            STR(ds).ReStatus = 0                            ' 
                            ' Hier stellen wir den bentigten Speicher entsprechend der Feldanzahl bereit
                            ReDim STR(ds).ReFields(GlobalDefs.DsbFieldCount)
                            ' Die Datensatzlnge setzen wir zunchst auf Null
                            DSLength = 0

                            ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
                            For fi As Integer = 0 To GlobalDefs.DsbFieldCount - 1
                                ' Zu jedem Feld die Informationen ermitteln und Speichern
                                Select Case m_nLinkDLLType
                                    Case 1 ' Declare
                                        CallingVariations.DFCDatBFeld_Declare(1, ds, fi, DSField, DSFieldTyp, DSFieldLength)
                                    Case 2 ' Import
                                    Case 3 ' Unicode
                                    Case 4 ' ANSI 
                                        CallingVariations.DFCDatBFeld_ANSI(1, ds, fi, DSField, DSFieldTyp, DSFieldLength)
                                    Case 5 ' Auto
                                End Select
                                STR(ds).ReFields(fi).FiName = DSField         ' Name des Feldes
                                STR(ds).ReFields(fi).FiTyp = DSFieldTyp       ' Typ des Feldes
                                STR(ds).ReFields(fi).FiLength = DSFieldLength ' Feldlnge in Byte
                                STR(ds).ReFields(fi).FiValue = ""            ' Feldwert
                                ' Hier rechnen wir die Datensatzlnge zusammen
                                DSLength = DSLength + DSFieldLength

                                ' Wir geben hier ein Feedback fr den Anwender
                                RichDataBox.AppendText("Metadaten eines Feldes ermitteln: <DFCDatBFeld()>")
                                RichDataBox.AppendText(vbCrLf)
                            Next fi

                            ' Die Datensatzlnge wird natrlich auch zur Datensatzbeschreibung gespeichert
                            STR(ds).ReLength = DSLength
                            ' Nchste Datensatzbeschreibung

                            ' Wir geben hier ein Feedback fr den Anwender
                            RichDataBox.AppendText("Metadaten einer Datensatzbeschreibung  ermitteln: <DFCDatBDatensatz()>")
                            RichDataBox.AppendText(vbCrLf)
                        Next ds

                        ' Genug Vorbereitung, jetzt die Daten lesen
                        ' Zunchst speichern wir die Daten in einer Liste zwischen, um zu ermitteln wie viel Speicher wir bentigen
                        ' Wir gehen davon aus, dass es min. einen Datensatz gibt, daher die 1
                        DSStatus = 1
                        ' Wir lesen so lange weiter, bis es "keine Daten = 0" mehr gibt
                        Do While DSStatus > 0
                            DSLength = 0
                            Datensatz = New String(Slength)
                            Select Case m_nLinkDLLType
                                Case 1 ' Declare
                                    DSStatus = CallingVariations.DFCReadRecord_Declare(1, 254, Datensatz, DSLength, nComError)
                                Case 2 ' Import
                                Case 3 ' Unicode
                                Case 4 ' ANSI 
                                    DSStatus = CallingVariations.DFCReadRecord_ANSI(1, 254, Datensatz, DSLength, nComError)
                                Case 5 ' Auto
                            End Select

                            ' Wir geben hier ein Feedback fr den Anwender
                            RichDataBox.AppendText("Einen Datensatz lesen: <DFCReadRecord()>")
                            RichDataBox.AppendText(vbCrLf)

                            ' Wenn wir einen Datensatz gelesen haben wird er gesichert
                            If (DSStatus > 0) Then
                                ' Datensatz wird in unsere Liste geschrieben normalerweise wrde hier
                                ' eine Datei zum Einsatz kommen. 

                                ' hier werden wir den Datensatz in einen lesbaren String konvertieren
                                Dim szDatensatz As String
                                szDatensatz = GetData(Datensatz, STR, 0)

                                ' hier wird jetzt der gelesene Datensatz gesichert
                                Dim szCurrentDir As String
                                ' Default Speicherort fr die Daten ist immer das Programmverzeichnis
                                szCurrentDir = System.Environment.CurrentDirectory.ToString
                                ' Default werden die Daten immer im ASCII *.txt Format abgelegt
                                Dim szExtention As String
                                szExtention = ".txt"
                                ' Hier holen wir uns die Nummer der Datensatzbeschreibung
                                Datensatz = Datensatz(0)
                                Dim iDSNum As Integer
                                Dim szChar As Char
                                ' Nur das erste Byte des Datensatzes ist die Nummer
                                szChar = Datensatz.Substring(0, 1)
                                Select Case (szChar)
                                    Case Chr(0)
                                        iDSNum = 0
                                    Case Chr(1)
                                        iDSNum = 1
                                    Case Chr(2)
                                        iDSNum = 2
                                    Case Chr(3)
                                        iDSNum = 3
                                    Case Chr(4)
                                        iDSNum = 4
                                    Case Chr(5)
                                        iDSNum = 5
                                    Case Chr(6)
                                        iDSNum = 6
                                        ' Hier sind max. 20 Datensatzbeschreibungen mglich
                                End Select

                                ' Jetzt wo wir die Nummer der Datensatzbeschreibung kenn, knnen wir die 
                                ' Detailinformationen zum Datensatz ermitteln
                                ' Name der Datensatzbeschreibung
                                Dim szFileName As String
                                Dim iIndex = STR(iDSNum).ReName.IndexOf(Chr(0))

                                ' Hier sollte der FileDialog geffnet werden, um die Daten zu speichern!
                                szFileName = szCurrentDir & "\" & STR(iDSNum).ReName.Substring(0, iIndex) & ".txt"

                                ' Wenn die Datei fr entsprechend der Datensatzbeschreibung
                                ' fr die Daten noch nicht existiert, dann erstellen
                                ' Schreibobjekt erzeugen
                                Dim objStreamWriter As System.IO.StreamWriter

                                ' Alle Daten werden an eine bestehende Datei angefgt
                                ' Wenn die Datei nicht existiert, wird sie erzeugt
                                objStreamWriter = New System.IO.StreamWriter(szFileName, True)

                                ''Dim szOutput As String
                                ''szOutput = szDatensatz.ToString.Replace(Chr(0), " ")

                                ' Hier die Daten in die Datei schreiben
                                ''objStreamWriter.Write(szOutput)
                                objStreamWriter.Write(szDatensatz)

                                ' Wenn der Datensatz geschrieben werden konnte, hier noch ein Feedback
                                ''RichDataBox.AppendText(szOutput)
                                RichDataBox.AppendText(szDatensatz)
                                RichDataBox.Update()
                                ' Wenn wir die Daten geschrieben haben, dann die Datei noch schlieen
                                objStreamWriter.Close()

                                ' An dieser Stelle ist es sehr wichtig, dass diese Funktion erst dann aufgerufen
                                ' wird, wenn die Daten in einer Datei auf einem Laufwerk gesichert wurden.
                                ' Daher auch oben der Hinweis auf die Datei.
                                ' Mit diesem Aufruf werden die Daten im Gert gelscht.
                                Select Case m_nLinkDLLType
                                    Case 1 ' Declare
                                        CallingVariations.DFCQuitRecord_Declare(1, 254, nComError)
                                    Case 2 ' Import
                                    Case 3 ' Unicode
                                    Case 4 ' ANSI 
                                        CallingVariations.DFCQuitRecord_ANSI(1, 254, nComError)
                                    Case 5 ' Auto
                                End Select

                                ' Wir geben hier ein Feedback fr den Anwender
                                RichDataBox.AppendText("Einen gelesenen Datensatz quittieren: <DFCQuitRecord()>")
                                RichDataBox.AppendText(vbCrLf)

                            End If
                        Loop

                        If (DSStatus = -1) Then
                            ' Der Rckgabewert von DFCReadRecord_... ist kleiner als 0.
                            ' Hier geben wir den aufgetretenen Fehler aus
                            CallExseptionInfo(Convert.ToInt32(1), nComError, 0, szComError, szComError.Length(), MsgStyle, "Fehler bei DFCReadRecord", m_sLinkDLLType, "")
                        End If
                    Else
                        ' Der Rckgabewert von DFCLoadDatensatzbeschreibung_... ist 0 
                        ' Hier geben wir den aufgetretenen Fehler aus
                        CallExseptionInfo(Convert.ToInt32(1), nComError, 0, szComError, szComError.Length(), MsgStyle, "Fehler bei DFCLoadDatensatzbeschreibung", m_sLinkDLLType, "")
                    End If
                    ' Wenn keine Daten mehr im Gert sind, knnen wir nun das Firmwarupdate durchfhren
                    ' hier das Firmwareupdate durchfhren
                    Select Case m_nLinkDLLType
                        Case 1 ' Declare
                            iDFComResult = CallingVariations.DFCUpload_Declare(1, 254, m_sFirmware.ToString().Trim(), nComError)
                        Case 2 ' Import
                        Case 3 ' Unicode
                        Case 4 ' ANSI 
                            iDFComResult = CallingVariations.DFCUpload_ANSI(1, 254, m_sFirmware.ToString().Trim(), nComError)
                        Case 5 ' Auto
                    End Select

                    ' Wir geben hier ein Feedback fr den Anwender
                    RichDataBox.AppendText("Firmwareupdate durchfhren: <DFCUpload()>")
                    RichDataBox.AppendText(vbCrLf)

                    If (iDFComResult = 0) Then
                        ' Der Rckgabewert von DFCUpload_... ist 0.
                        ' Hier geben wir den aufgetretenen Fehler aus
                        CallExseptionInfo(Convert.ToInt32(1), nComError, 0, szComError, szComError.Length(), MsgStyle, "Fehler bei DFCUpload", m_sLinkDLLType, "")
                    End If
                Else
                    ' Der Anwender hat bei der Abfrage, ob die Daten aus dem Gert 
                    ' gelesen werden sollen, auf NEIN geklickt. 
                    ' Daher ist an diesr Stelle Schluss!!!
                End If
            Else
                ' Es ist ein anderer Fehlercode aufgetreten, als 15 = Daten im Gert.
                ' Hier geben wir den aufgetretenen Fehler aus.
                CallExseptionInfo(Convert.ToInt32(1), nComError, 0, szComError, szComError.Length(), MsgStyle, "Fehler bei DFCUpload", m_sLinkDLLType, "")
            End If
        Else
            ' Wir geben hier ein Feedback fr den Anwender
            RichDataBox.AppendText("Firmwareupdate durchfhren: <DFCUpload()>")
            RichDataBox.AppendText(vbCrLf)
        End If

    End Sub


    Private Sub DateTime_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DateTime.Click

        Dim MsgStyle As MsgBoxStyle
        Dim MsgStyle2 As MsgBoxStyle
        MsgStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly
        MsgStyle2 = MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly

        Dim iDFComResult As Integer
        ' Hier holen wir uns die aktuelle Systemzeit
        Dim aktDateTime As DateTime
        aktDateTime = Now()
        Dim myDt As DateTime
        Dim szDateTimeW As String
        Dim szDateTimeR As String
        Dim datePatt As String = "MM.dd.yyyy HH:mm:ss tt"


        Select Case m_nLinkDLLType
            Case 1 ' Declare
                iDFComResult = CallingVariations.DFCComSetTime_Declare(1, 254, aktDateTime.ToString())
            Case 2 ' Import
            Case 3 ' Unicode
            Case 4 ' ANSI 
                iDFComResult = CallingVariations.DFCComSetTime_ANSI(1, 254, aktDateTime.ToString())
            Case 5 ' Auto
        End Select

        If (iDFComResult = 0) Then
            ' Es ist ein anderer Fehlercode aufgetreten, als 15 = Daten im Gert.
            ' Hier geben wir den aufgetretenen Fehler aus.
            Get_Error_Information(m_sLinkDLLType, iDFComResult, "Keine Detailinformationen verfgbar!", MsgStyle, "Fehler bei DFCComSetTime", "")
        Else
            ' DateTime noch fr die Anzeige in Form bringen und speichern
            myDt = System.DateTime.SpecifyKind(aktDateTime, DateTimeKind.Local)
            szDateTimeW = aktDateTime.ToString(datePatt)

            Select Case m_nLinkDLLType
                Case 1 ' Declare
                    iDFComResult = CallingVariations.DFCComGetTime_Declare(1, 254, aktDateTime.ToString())
                Case 2 ' Import
                Case 3 ' Unicode
                Case 4 ' ANSI 
                    iDFComResult = CallingVariations.DFCComGetTime_ANSI(1, 254, aktDateTime.ToString())
                Case 5 ' Auto
            End Select
            If (iDFComResult = 0) Then
                ' Es ist ein anderer Fehlercode aufgetreten, als 15 = Daten im Gert.
                ' Hier geben wir den aufgetretenen Fehler aus.
                Get_Error_Information(m_sLinkDLLType, iDFComResult, "Die Terminalzeit wurde aktualisiert," & vbCrLf & "konnte jedoch nicht ausgelesen werden!", MsgStyle, "Fehler bei DFCComGetTime", "")
            Else
                ' DateTime noch fr die Anzeige in Form bringen und speichern
                myDt = System.DateTime.SpecifyKind(aktDateTime, DateTimeKind.Local)
                szDateTimeR = aktDateTime.ToString(datePatt)

                ' Jetzt noch dem Anwender zeigen was wir gemacht haben
                MsgBox("Die Terminalzeit wurde erfolgreich aktualisiert!" & vbCrLf & _
                        "Geschriebene Systemzeit: " & vbTab & szDateTimeW & vbCrLf & _
                        "Gelesene Terminalzeit: " & vbTab & szDateTimeR & vbCrLf _
                                        , MsgStyle2, "Uhrzeit stellen")
            End If
        End If
    End Sub


    Private Sub FirmwareUpdate_Activated(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Activated

        Dim comError As Integer = 0
        Dim iSerial As Integer = 0
        Dim Firmware As String
        Dim length(33) As Char
        Firmware = New String(length)
        RichDataBox.Text = ""
        Dim st As String = ""

        If (m_nConnectState = 0) Then
            txSeriennummer.Text = ""
            txFirmware.Text = ""
        End If

        Select Case m_nLinkDLLType
            Case 1
                If (CallingVariations.DFCGetSerial_Declare(1, 254, comError, iSerial) = 1) Then
                    txSeriennummer.Text = iSerial.ToString()
                End If

                If (CallingVariations.DFCGetVersionFirmware_Declare(1, 254, Firmware, comError) = 1) Then
                    txFirmware.Text = Firmware
                End If
            Case 2
            Case 3
            Case 4
                If (CallingVariations.DFCGetSerial_ANSI(1, 254, comError, iSerial) = 1) Then
                    txSeriennummer.Text = iSerial.ToString()
                End If

                If (CallingVariations.DFCGetVersionFirmware_ANSI(1, 254, Firmware, comError) = 1) Then
                    txFirmware.Text = Firmware
                End If
            Case 5
        End Select
        ' Wir geben hier ein Feedback fr den Anwender
        RichDataBox.AppendText("Seriennummer des Gertes ermitteln mit: <DFCGetSerial()>")
        RichDataBox.AppendText(vbCrLf)
        RichDataBox.AppendText("Firmwareversion des Gertes ermitteln mit: <DFCGetVersionFirmware()>")
        RichDataBox.AppendText(vbCrLf)

    End Sub
End Class