/**
 * @file  DFFileDeviceText.h
 * @brief Schnittstelle fuer die Klasse CDFFileDeviceText.
 */
//////////////////////////////////////////////////////////////////////
#ifndef _DFFILEDEVICETEXT_H_
#define _DFFILEDEVICETEXT_H_

// Basisklasse 
#include "DFFileIntelHex.h"

// Strukturdefinitionen
#include "../Common/pzemaiv.h"
// CRC berechnungsroutinen
#include "../Common/crc.h"

#ifdef _WIN32
#pragma warning(disable : 4996)
#endif

class CDFFileDeviceText : public CDFFileIntelHex
{
public:
	CDFFileDeviceText();
	virtual ~CDFFileDeviceText();

	void Reset();
	inline unsigned int GetSizeData() { return (unsigned int)m_sizeData; };

	int Load(char *fileName);
	int Save(char *fileName, unsigned char append = 0);
	char *DefaultDFL();
	
	int Import(char *fileName);
	int ParseLineFromHeader(char *data, unsigned short &id, char **format, char **text, unsigned int &flags);
	int ParseLineFromDefault(char *data, unsigned short &id, char **format, char **text, unsigned int &flags);
	void ConvertControlCharacters(char **text);

public:
	size_t m_sizeData;
	unsigned char *m_memData;
	unsigned int m_sizeDefaultDFL;
	char *m_memDefaultDFL;
};

#endif

