/**
 * @file  DFFileTouchKeys.h
 * @brief Schnittstelle fuer die Klasse CDFFileTouchKeys.
 */
//////////////////////////////////////////////////////////////////////
#ifndef _DFFILETOUCHKEYS_H_
#define _DFFILETOUCHKEYS_H_

#ifdef _WIN32
#pragma warning(disable : 4996)
#endif

// Verwaltungsklasse fuer Datei
#include "DFFileIntelHex.h"
// 16bit/32bit CRC
#include "../Common/crc.h"

// Strukturdefinitionen
#include "../Common/pzemaiv.h"

// Maximale Anzahl Datenbyte (1kByte)
#define MAX_MEM_TOUCHKEYS   0x400

// Maximale Anzahl TouchKeys
#define MAX_TOUCHKEYS   100

class CDFFileTouchKeys : public CDFFileIntelHex
{
public:
	CDFFileTouchKeys();
	virtual ~CDFFileTouchKeys();

public:
	unsigned int m_sizeData;

	// Verwaltungsstrukturen fuer TouchKey
	TOUCHKEYNODE *m_pTouchKeysNode;
	TOUCHKEY     *m_pTouchKeys[MAX_TOUCHKEYS];

	// Speicher fuer alle Daten
	unsigned char m_memTouchKeys[MAX_MEM_TOUCHKEYS];

public:
	void Reset();
	int Load(char *fileName);
	int Save(char *fileName, unsigned char append = 0);
	inline unsigned int GetSizeData() { return m_sizeData; };
  void Init(unsigned char count);
	int SetTouchKey(int idx, TOUCHKEY tk);
	TOUCHKEY GetTouchKey(int idx);
	int GetTouchKeyCount()
	{
		return m_pTouchKeysNode->cnt;
	}

protected:
	int SaveTouchKeys(char *fileName, unsigned char append = 0);
};

#endif

